searchData={"items":[{"type":"module","title":"GlueSQL","doc":"GlueSQL is a SQL database library for Elixir.  \nThis repository is an Elixir binding of the original Rust library [`gluesql-rs`](https://github.com/gluesql/gluesql).","ref":"GlueSQL.html"},{"type":"module","title":"Just another SQL database library? - GlueSQL","doc":"#","ref":"GlueSQL.html#module-just-another-sql-database-library"},{"type":"module","title":"Various Storage Engines - GlueSQL","doc":"GlueSQL supports various storages(pre-existing databases, files, etc), already implemented in `gluesql-rs`.\n\nThe list of supported storages are:\n\n- [x] In-Memory\n- [ ] Redis\n- [ ] MongoDB Storage\n- [ ] JSON file\n- [ ] CSV file\n- [ ] IDB\n- [ ] [`sled`](https://docs.rs/sled/latest/sled/), a high-performant database written with Rust.\n\n...and much more will be supported in future.  \n(Unchecked items are yet bound to GlueSQL Elixir library).\n\n#","ref":"GlueSQL.html#module-various-storage-engines"},{"type":"module","title":"With-or-without schema - GlueSQL","doc":"Unlike most of the SQL databases, GlueSQL supports not only schema-enabled queries but also schema-less queries.\n\nIt's better understood by reading the example below.","ref":"GlueSQL.html#module-with-or-without-schema"},{"type":"module","title":"Example - GlueSQL","doc":"```elixir\nalias GlueSQL.Storages.MemoryStorage\nalias GlueSQL\n\n# Create SQL database with memory storage\ndb =\n  MemoryStorage.new()\n  |> GlueSQL.glue_new()\n\n# Create table with schema\nGlueSQL.query(db, \"CREATE TABLE users (id INTEGER, name STRING);\")\n\n# Insert values\nGlueSQL.query(db, \"\"\"\n        INSERT INTO users VALUES\n        (1, \"Hoon Wee\"),\n        (2, \"Eunbee Cho\");\n        \"\"\")\n\n# We can also create table WITHOUT schema\nGlueSQL.query(db, \"CREATE TABLE friends;\")\n\n# Insert values\nGlueSQL.query(db, \"\"\"\n        INSERT INTO friends VALUES\n        ('{ \"name\": \"Hoon Wee\" }'),\n        ('{ \"username\": \"Eunbee Cho\", \"age\": 12 }');\n        \"\"\")\n```","ref":"GlueSQL.html#module-example"},{"type":"module","title":"Installation - GlueSQL","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `gluesql` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:gluesql, \"~> 0.1.0\"}\n  ]\nend\n\n```","ref":"GlueSQL.html#module-installation"},{"type":"function","title":"GlueSQL.glue_new/1","doc":"Create a GlueSQL database with given storage engine.","ref":"GlueSQL.html#glue_new/1"},{"type":"function","title":"Example: Create a SQL database that runs on in-memory storage. - GlueSQL.glue_new/1","doc":"alias GlueSQL.Storages.MemoryStorage\n\n    db =\n      MemoryStorage.new()\n      |> GlueSQL.glue_new()","ref":"GlueSQL.html#glue_new/1-example-create-a-sql-database-that-runs-on-in-memory-storage"},{"type":"function","title":"GlueSQL.query/2","doc":"Execute given query for database.\nSQL query should be provided as string format.","ref":"GlueSQL.html#query/2"},{"type":"function","title":"Example: Create tables (with-or-without schema). - GlueSQL.query/2","doc":"GlueSQL.query(db, \"\"\"\n         CREATE TABLE Foo (id INTEGER); # schema\n         CREATE TABLE Bar; #schema-less\n         \"\"\")","ref":"GlueSQL.html#query/2-example-create-tables-with-or-without-schema"},{"type":"module","title":"GlueSQL.Native","doc":"","ref":"GlueSQL.Native.html"},{"type":"function","title":"GlueSQL.Native.glue_new/1","doc":"","ref":"GlueSQL.Native.html#glue_new/1"},{"type":"function","title":"GlueSQL.Native.glue_query/2","doc":"","ref":"GlueSQL.Native.html#glue_query/2"},{"type":"function","title":"GlueSQL.Native.memory_storage_new/0","doc":"","ref":"GlueSQL.Native.html#memory_storage_new/0"},{"type":"module","title":"GlueSQL.Storages","doc":"To properly create SQL database with `GlueSQL.glue_new()`, the user \nshould create storage instance first.  \n\n`GlueSQL.Storages` module has a list of usable storages.","ref":"GlueSQL.Storages.html"},{"type":"module","title":"GlueSQL.Storages.MemoryStorage","doc":"Methods for creating and using memory storage.","ref":"GlueSQL.Storages.MemoryStorage.html"},{"type":"function","title":"GlueSQL.Storages.MemoryStorage.new/0","doc":"Create in-memory storage instance.","ref":"GlueSQL.Storages.MemoryStorage.html#new/0"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"About version number - Changelog","doc":"The version number of this library is synchronized with [`gluesql-rs`](https://github.com/gluesql/gluesql).","ref":"changelog.html#about-version-number"}],"content_type":"text/markdown"}